from sqlite3 import *
from gpanel import *

makeGPanel(1860, 2040, -2.5, 2.5)
drawGrid(1880, 2020, -2.0, 2, 14, 8, "darkgray")
title("Mean Global Temperature Anomalie from 1880 to 2016")
text(1865, 2.2, "Deg (C)")
with connect("climate.db") as con:
    cursor = con.execute("SELECT Year, Glob FROM temp") 
    result = cursor.fetchall()
    nbData = len(result)
    xval = [0] * nbData
    yval = [0] * nbData
    for n in range(nbData):
        xval[n] = int(result[n][0])
        yval[n] = float(result[n][1])
for n in range(nbData):
    if n == 0:
        pos(xval[n], yval[n] / 100)
    else:
        draw(xval[n], yval[n] / 100)

xSmooth = []
ySmooth = []        
period = 10
for n in range(nbData - period):
    total = 0
    for m in range(period):        
        total += yval[n + m]
    ySmooth.append(total / period)
    xSmooth.append(xval[n + period // 2])

setColor("red")
lineWidth(2)
for n in range(len(xSmooth)):
    if n == 0:
        pos(xSmooth[n], ySmooth[n] / 100)
    else:
        draw(xSmooth[n], ySmooth[n] / 100)

